package tracematches;

import java.util.*;

public class ASyncIteration {
	
	/**
	 * Tests a property mentioned in (see {@link Collections#synchronizedCollection(Collection)}),
	 * which says that one should only iterate over a synchronized collection from within
	 * a synchronized block.
	 */
	
	static aspect SyncCheck{
		
		/*
		 * Those tracechecks check that one does not directly access a Map or Collection
		 * that has been put into Collections.synchronized*(..).
		 */		
		
		pointcut createSync(): call(* Collections.synchr*(..)) && !within(dacapo..*);
		
		//most common supertype of Map anc Collection is Object unfortunately
		tracematch(Object sync) {
			
			sym sync after returning(sync): createSync();
			
			sym asyncIteration before: call(* Collection+.iterator()) && target(sync) && if(!Thread.holdsLock(sync));			

			sync asyncIteration {
				if(System.getProperty("TMTEST_ACTIVE")!=null) {
					throw new IllegalStateException("Collection "+System.identityHashCode(sync)+
						" is synchronized. You may only iterate from within a synchronized block.");
				}
			}
			
		}

	}
			
}
